const WHITE_SPACES = [' ', '\n', '\r', '\t', '\f', '\v', '\u00A0', '\u1680', '\u180E', '\u2000', '\u2001', '\u2002', '\u2003', '\u2004', '\u2005', '\u2006', '\u2007', '\u2008', '\u2009', '\u200A', '\u2028', '\u2029', '\u202F', '\u205F', '\u3000'];




const loadScript = (src, method = 'async', type) => {
  return new Promise((resolve, reject) => {
    let script = document.createElement('script');
    script.setAttribute(method, '');
    if (type) script.setAttribute('type', type);
    script.onload = result => {
      resolve(result);
    };
    script.onerror = error => {
      reject(error);
    };
    script.src = src;
    document.body.appendChild(script);
  });
};


let sheduled = false;
const afterRenderQue = [];
const beforeRenderQue = [];
const callMethod = array => {
  const context = array[0];
  const callback = array[1];
  const args = array[2];
  try {
    callback.apply(context, args);
  } catch (e) {
    setTimeout(() => {
      throw e;
    });
  }
};
const flushQue = que => {
  while (que.length) {
    callMethod(que.shift);
  }
};
const runQue = que => {
  for (let i = 0, l = que.length; i < l; i++) {
    callMethod(que.shift());
  }
  sheduled = false;
};
const shedule = () => {
  sheduled = true;
  requestAnimationFrame(() => {
    flushQue(beforeRenderQue);
    setTimeout(() => {
      runQue(afterRenderQue);
    });
  });
};
const RenderStatus = (() => {
  window.RenderStatus = window.RenderStatus || {
    afterRender: (context, callback, args) => {
      if (!sheduled) {
        shedule();
      }
      afterRenderQue.push([context, callback, args]);
    },
    beforeRender: (context, callback, args) => {
      if (!sheduled) {
        shedule();
      }
      beforeRenderQue.push([context, callback, args]);
    }
  };
})();

const bowerMinUrl = (name, main, root) => {
  const url = main ? `${name}/${main}` : `${name}/${name}`;
  return `${root}/${url}.min.js`;
};
const ensureArray = array => {
  if (Array.isArray(array)) {
    return array;
  }
  return [...array];
};
var polyLoader = ((fills, root = 'bower_components') => {
  return new Promise((resolve, reject) => {
    fills = ensureArray(fills);
    fills = fills.map(fill => {
      let name;
      let main = null;
      if (typeof fill === 'object') {
        name = fill.name;
        main = fill.main;
      } else {
        name = fill;
      }
      if (name === 'shadycss' && !main) {
        main = 'custom-style-interface';
      }
      return loadScript(bowerMinUrl(name, main, root));
    });
    Promise.all(fills).then(() => resolve()).catch(error => reject(error));
  });
});

export default polyLoader;
//# sourceMappingURL=poly-loader.js.map
